﻿@using System.Web.Mvc; 
@using System.Web.UI.WebControls;
@using System.Data;
@using Portal.Models;
@using Portal.Controllers;
@using System.Web.Script.Serialization;

@model Toyota.Common.Web.MVC.ModelHolder

@*--- Reference about Master Detail Page : http://mvc.devexpress.com/GridView/MasterDetail *@
@*--- Created by : niit.yudha 18/10/2012  *@ 
@*--- Changed by : fid.salman 17-jan-2013 *@

@{
    Layout = "~/Views/Layout/Dashboard.cshtml";
}

@section StartupScript {
    @*ForecastDetailView.Refresh();*@

    $('#FHProductionMonthText_I').monthpicker({
        startYear: new Date().getFullYear() - 5,
        finalYear: new Date().getFullYear() + 1,
        pattern: 'mmm yyyy', 
        monthNames: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
    });

    $('#FHProductionMonthText_I').bind('onchange',function(e){
        alert("input change");
    });

    $('#HFSProductionMonthText').monthpicker({
        startYear: new Date().getFullYear() - 5,
        finalYear: new Date().getFullYear() + 1,
        pattern: 'mmm yyyy', 
        monthNames: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
    });

    $('#HFSProductionMonthText').bind('onchange',function(e){
        alert("input change");
    });

    Date.isLeapYear = function (year) {
        return (((year % 4 === 0) && (year % 100 !== 0)) || (year % 400 === 0));
    };

    Date.getDaysInMonth = function (year, month) {
        return [31, (Date.isLeapYear(year) ? 29 : 28), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31][month];
    };

    Date.prototype.isLeapYear = function () {
        return Date.isLeapYear(this.getFullYear());
    };

    Date.prototype.getDaysInMonth = function () {
        return Date.getDaysInMonth(this.getFullYear(), this.getMonth());
    };

    Date.prototype.addMonths = function (value) {
        var n = this.getDate();
        this.setDate(1);
        this.setMonth(this.getMonth() + value);
        this.setDate(Math.min(n, this.getDaysInMonth()));
        return this;
    };

    var today = new Date().addMonths(1); 
    productionMonth = today.getFullYear() + pad(today.getMonth()+1).toString();
    FHProductionMonthText_I.value = GetRegularProductionMonth(productionMonth);

    GridFHSupplierIDOption.PerformCallback();
}

<script src="@Url.Content("~/Scripts/jquery.mtz.monthpicker.js")" type="text/javascript"></script>

@section Style{
    .ui-datepicker.ui-corner-all { -moz-border-radius: 4px; -webkit-border-radius: 4px; border-radius: 4px; }
    .iu-widget-header { background-color: #94B6E8; color: #94B6E8; }
    .ui-widget-header {
        background: url("images/ui-bg_highlight-soft_15_cc0000_1x100.png") repeat-x scroll 50% 50% #94B6E8;
        background-color: #DDECFF;
        border: 1px solid #94B6E8;
        color: #94B6E8;
        font-weight: bold;
    }
    div.ui-datepicker {width: 17em; padding: .2em .2em 0;}
    div.ui-datepicker-header.mtz-monthpicker {border: 1px solid #DDECFF; background-color: #DDECFF; color: #DDECFF; font-weight: bold;}
    table.mtz-monthpicker {width: 100%; font-size: .9em; border-collapse: collapse; margin:0 0 .4em; }
    td.ui-state-default.mtz-monthpicker-month {border: 1px solid #fff;}
    td.ui-state-default.mtz-monthpicker-month {text-align: center; cursor: pointer; padding: 5px;}
    td.ui-state-default.mtz-monthpicker-month:hover, td.ui-state-default.mtz-monthpicker-month-selected {background: none; background-color: #DDECFF; color: #fff; cursor: pointer;}
    td.ui-state-default.mtz-monthpicker-month:hover {background-color: #fff; color: #000;}
    select.mtz-monthpicker-year {margin-top: 7px;}
}

@section Script{
}

<script type="text/javascript">
    // =========================== Parameter Variabels =============================
    var productionMonth = "";
    var supplierCode = "";
    var supplierPlanCode = "";
    var version = "";
    var tlock = "";
    var flock = "";
    var lock = "";

    var filePath = "";
    var parameterList = "";
    var isOverAllNGN_Month = false;
    var isOverAllNGN_1_Month = false;
    var isOverAllNGN_2_Month = false;
    var isOverAllNGN_3_Month = false;
    var isKey;

    var isUpload = false;
    // =============================================================================

    // ======================== Forecast Header Functions ==========================

    function NumericKey(e) {
        isKey = e.htmlEvent;
        if ($.inArray(isKey.keyCode, [46, 8, 9, 27, 13, 110, 190]) !== -1 ||
			(isKey.keyCode == 65 && isKey.ctrlKey === true) ||
			(isKey.keyCode >= 35 && isKey.keyCode <= 40)) {
            return;
        }

        if ((isKey.shiftKey || (isKey.keyCode < 48 || isKey.keyCode > 57)) && (isKey.keyCode < 96 || isKey.keyCode > 105)) {
            isKey.preventDefault();
        }
    }

    function OnFHToggleButtonClick(s, e) {
        ForecastDetailView.PerformCallback('ToggleColumns=TDownload;FDownload;PODownload;TFeedback;FFeedback');
    }

    function GetProductionMonth(productionMonth) {
        var paramStr = String(productionMonth).replace(' ', '');
        var paramStrLength = String(paramStr).length;

        var year = String(paramStr).substring(paramStrLength, paramStrLength - 4);
        var month = String(paramStr).substring(0, paramStrLength - 4);
        var monthEnum = {
            January: '01',
            February: '02',
            March: '03',
            April: '04',
            May: '05',
            June: '06',
            July: '07',
            August: '08',
            September: '09',
            October: '10',
            November: '11',
            December: '12'
        };
        var monthNum = "";
        if (Boolean(month))
            monthNum = monthEnum[month];

        return year + monthNum;
    }

    function GetRegularProductionMonth(productionMonth) {
        var year = String(productionMonth).substring(0, 4);
        var month = String(productionMonth).substring(String(productionMonth).length, String(productionMonth).length - 2);
        var monthEnum = {
            '01': 'January',
            '02': 'February',
            '03': 'March',
            '04': 'April',
            '05': 'May',
            '06': 'June',
            '07': 'July',
            '08': 'August',
            '09': 'September',
            '10': 'October',
            '11': 'November',
            '12': 'December'
        };

        return monthEnum[month] + " " + year;
    }

    function pad(n) {
        return (n < 10) && (n >= 0) ? ("0" + n) : n;
    }

    function OnFHSearchButtonClick(s, e) {
        ForecastDetailView.PerformCallback();
    }

    function OnFHClearButtonClick(s, e) {
        var today = new Date();

        var today = new Date().addMonths(2);
        productionMonth = today.getFullYear() + pad(today.getMonth()).toString();
        FHProductionMonthText_I.value = GetRegularProductionMonth(productionMonth);

        FHSupplierIDOption.SetValue();
        GridFHSupplierIDOption.UnselectRows();

        FHSupplierPlanCodeOption.SetValue();
        GridFHSupplierPlanCodeOption.UnselectRows();

        ForecastDetailView.ClearFilter();
    }

    function OnFHSupplierIDOptionButtonClick(s, e) {
        supplierCode = FHSupplierIDOption.GetValue();

        GridFHSupplierPlanCodeOption.PerformCallback();
    }

    function OnFHSupplierPlanCodeOptionBeginCallback(s, e) {
        e.customArgs["SupplierCode"] = supplierCode;
    }

    function OnFHProductionMonthTextTextChanged(s, e) {
        ForecastDetailView.PerformCallback();
    }
    // =============================================================================

    // ========================= Forecast Detail Functions =========================
    // Changed By   : fid.salman
    // Changed Date : 28.08.2013
    // Description  : Prevent multiple callback from ASPxClientGridView with disabling trigger control.
    function OnForecastHeaderPartialButtonEnabled(isEnabled) {
        FHToggleButton.SetEnabled(isEnabled);
        FHSearchButton.SetEnabled(isEnabled);
        FHClearButton.SetEnabled(isEnabled);
    }

    function OnForecastDetailViewInit(s, e) {
        OnForecastHeaderPartialButtonEnabled(true);
    }

    function OnForecastDetailViewBeginCallback(s, e) {
        OnForecastHeaderPartialButtonEnabled(false);
        e.customArgs["ProductionMonth"] = GetProductionMonth(FHProductionMonthText_I.value);
        e.customArgs["SupplierCode"] = FHSupplierIDOption.GetValue();
        e.customArgs["SupplierPlanCode"] = FHSupplierPlanCodeOption.GetValue();
    }

    function OnForecastDetailViewEndCallback(s, e) {
        OnForecastHeaderPartialButtonEnabled(true);
    }

    function OnForecastDetailViewRowClick(s, e) {
    }

    function OnFDLPOPTFileImageClick(s, e) {
        var index = s.name.substring(16);

        index = index - (ForecastDetailView.GetPageIndex() * ForecastDetailView.cpPageSize);

        productionMonth = ForecastDetailView.cpProductionMonth[index];
        supplierCode = ForecastDetailView.cpSupplierCd[index];
        supplierPlanCode = ForecastDetailView.cpSupplierPlant[index];
        version = 'T';

        popupForecastDetailDownloadConfirmation.Show();
    }

    function OnFDLPOPFFileImageClick(s, e) {
        var index = s.name.substring(16);

        index = index - (ForecastDetailView.GetPageIndex() * ForecastDetailView.cpPageSize);

        productionMonth = ForecastDetailView.cpProductionMonth[index];
        supplierCode = ForecastDetailView.cpSupplierCd[index];
        supplierPlanCode = ForecastDetailView.cpSupplierPlant[index];
        version = 'F';

        popupForecastDetailDownloadConfirmation.Show();
    }

    function OnFDDCOkButtonClick(s, e) {
        $("#FDDPMessageLabel").text("Download in progress,\nPlease wait...");
        popupForecastGridDownloadProgress.Show();

        var index = s.name.substring(16);
        index = index - (ForecastDetailView.GetPageIndex() * ForecastDetailView.cpPageSize);

        var downloadBy = FDDCDownloadByOption.GetSelectedIndex();

        $.fileDownload("Forecast/DownloadForecastDetailData/", {
            data: {
                productionMonth: GetProductionMonth($("#FDDCProductionMonthLabel").text()),
                supplierCode: $("#FDDCSupplierLabel").text().split('-')[0],
                supplierPlanCode: $("#FDDCSupplierLabel").text().split('-')[1],
                version: $("#FDDCVersionLabel").text().substring(0, 1),
                downloadBy: downloadBy
            },
            successCallback: function (result) {
                popupForecastGridDownloadProgress.Hide();
                popupForecastDetailDownloadConfirmation.Hide();
            },
            failCallback: function (result) {
                popupForecastGridDownloadProgress.Hide();
                popupForecastDetailDownloadConfirmation.Hide();

                alert("Error On Download Montly Forecast Data.");
            }
        });

        ForecastDetailView.PerformCallback();
    }

    function OnFDDCCancelButtonClick(s, e) {
        popupForecastDetailDownloadConfirmation.Hide();
    }

    function OnPopupForecastDetailDownloadConfirmationShown(s, e) {
        $("#FDDCProductionMonthLabel").text(GetRegularProductionMonth(productionMonth));
        $("#FDDCSupplierLabel").text(supplierCode + (supplierPlanCode == false ? '' : ('-' + supplierPlanCode)));
        $("#FDDCVersionLabel").text(version == 'T' ? 'Tentative' : 'Firm');
    }

    function OnFDTentativeUnlockImageClick(s, e) {
        var index = s.name.substring(22);

        index = index - (ForecastDetailView.GetPageIndex() * ForecastDetailView.cpPageSize);

        productionMonth = ForecastDetailView.cpProductionMonth[index];
        supplierCode = ForecastDetailView.cpSupplierCd[index];
        supplierPlanCode = ForecastDetailView.cpSupplierPlant[index];
        version = 'T';

        if (ForecastDetailView.cpTLockStatus[index])
            popupForecastDetailUnlockConfirmation.Show();
    }

    function OnFDFirmUnlockImageClick(s, e) {
        var index = s.name.substring(17);

        index = index - (ForecastDetailView.GetPageIndex() * ForecastDetailView.cpPageSize);

        productionMonth = ForecastDetailView.cpProductionMonth[index];
        supplierCode = ForecastDetailView.cpSupplierCd[index];
        supplierPlanCode = ForecastDetailView.cpSupplierPlant[index];
        version = 'F';

        if (ForecastDetailView.cpFLockStatus[index])
            popupForecastDetailUnlockConfirmation.Show();
    }

    function OnPopupForecastDetailUnlockConfirmationShown(s, e) {
        $("#FDUCProductionMonthLabel").text(GetRegularProductionMonth(productionMonth));
        $("#FDUCSupplierLabel").text(supplierCode + (supplierPlanCode == false ? '' : ('-' + supplierPlanCode)));
        $("#FDUCVersionLabel").text(version == 'T' ? 'Tentative' : 'Firm');
    }

    function OnFDUCOkButtonClick(s, e) {
        $.ajax({
            type: "POST",
            url: "@Url.Content("~/Forecast/UnlockForecast")",
            data: {
                productionMonth: GetProductionMonth($("#FDUCProductionMonthLabel").text()),
                supplierCode: $("#FDUCSupplierLabel").text().split('-')[0],
                supplierPlanCode: supplierPlanCode,
                version: $("#FDUCVersionLabel").text().substring(0, 1)
            },
            success: function (result) {
                popupForecastDetailUnlockConfirmation.Hide();
            },
            error: function (result) {
                popupForecastDetailUnlockConfirmation.Hide();

                alert("Error On Unlock Monthly Forecast Data.");
            }
        });
    }

    function OnFDUCCancelButtonClick(s, e) {
        popupForecastDetailUnlockConfirmation.Hide();
    }
    // =============================================================================

    // ==================== Common Forecast Popup Functions ========================
    function OnPopupFeedbackBeginCallback(s, e) {
        e.customArgs["ProductionMonth"] = productionMonth;
        e.customArgs["SupplierCode"] = supplierCode;
        e.customArgs["SupplierPlanCode"] = supplierPlanCode;
        e.customArgs["Version"] = version;
        e.customArgs["Lock"] = lock;
    }

    function OnPopupFeedbackClosing(s, e) {
        ForecastDetailView.PerformCallback();
        SFPGFSupplierFeedbackPartView.ClearFilter();
    }
    // =============================================================================

    // =============== Forecast Feedback Part Popup Functions ======================

    // handle row seleciton with overal capability drop down list.

    function OnSFPRHFOverallCapabilityOptionSelectedIndexChanged(fieldName, fieldValue) {

        // get previous stored radio button list sellection list.
        var previousSelectionList = [];
        previousSelectionList = SFPGFSupplierFeedbackPartViewSelectionLabel.GetValue().split(';');
        if (previousSelectionList[0] != null && previousSelectionList[0] != '')
            SFPGFSupplierFeedbackPartView.cpNReply = previousSelectionList[0].split(',');
        if (previousSelectionList[1] != null && previousSelectionList[1] != '')
            SFPGFSupplierFeedbackPartView.cpN1Reply = previousSelectionList[1].split(',');
        if (previousSelectionList[2] != null && previousSelectionList[2] != '')
            SFPGFSupplierFeedbackPartView.cpN2Reply = previousSelectionList[2].split(',');
        if (previousSelectionList[3] != null && previousSelectionList[3] != '')
            SFPGFSupplierFeedbackPartView.cpN3Reply = previousSelectionList[3].split(',');

        getPreviousNGData();

        var chkBoxPlantCap = '';
        var chkBoxRawComp = '';
        var chkBoxRawMat = '';
        var txtSupply = '';

        for (var index = SFPGFSupplierFeedbackPartView.cpStartIndex; index < SFPGFSupplierFeedbackPartView.cpEndIndex; index++) {
            switch (fieldName) {
                case 'N_MONTH':
                    if (index >= SFPGFSupplierFeedbackPartView.GetTopVisibleIndex() &&
                        index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() + (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {
                        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_REPLY" + index);
                        if (radioButtonList != null) {
                            // this block code (set radio button list selected index) only occur for showed page. not
                            // other page index of gridview
                            radioButtonList.SetSelectedIndex(fieldValue);
                        }

                        changeNGInput(index, fieldValue, "");
                    }

                    SFPGFSupplierFeedbackPartView.cpNReply[index] = fieldValue;

                    if (Number(fieldValue) !== 1) {
                        SFPGFSupplierFeedbackPartView.cpNPlant_Cap[index] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpNRaw_Comp[index] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpNRaw_Mat[index] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpNSupply[index] = "";
                        isOverAllNGN_Month = false;
                    }
                    else
                        isOverAllNGN_Month = true;

                    break;
                case 'N_1_MONTH':
                    if (index >= SFPGFSupplierFeedbackPartView.GetTopVisibleIndex() &&
                        index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() + (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {
                        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_1_REPLY" + index);
                        if (radioButtonList != null) {
                            // this block code (set radio button list selected index) only occur for showed page. not
                            // other page index of gridview
                            radioButtonList.SetSelectedIndex(fieldValue);
                        }

                        changeNGInput(index, fieldValue, "N_1_");
                    }

                    SFPGFSupplierFeedbackPartView.cpN1Reply[index] = fieldValue;

                    if (Number(fieldValue) !== 1) {
                        SFPGFSupplierFeedbackPartView.cpN1Plant_Cap[index] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN1Raw_Comp[index] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN1Raw_Mat[index] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN1Supply[index] = "";
                        isOverAllNGN_1_Month = false;
                    }
                    else
                        isOverAllNGN_1_Month = true;

                    break;
                case 'N_2_MONTH':
                    if (index >= SFPGFSupplierFeedbackPartView.GetTopVisibleIndex() &&
                        index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() + (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {
                        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_2_REPLY" + index);
                        if (radioButtonList != null) {
                            // this block code (set radio button list selected index) only occur for showed page. not
                            // other page index of gridview
                            radioButtonList.SetSelectedIndex(fieldValue);
                        }

                        changeNGInput(index, fieldValue, "N_2_");
                    }

                    SFPGFSupplierFeedbackPartView.cpN2Reply[index] = fieldValue;

                    if (Number(fieldValue) !== 1) {
                        SFPGFSupplierFeedbackPartView.cpN2Plant_Cap[index] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN2Raw_Comp[index] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN2Raw_Mat[index] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN2Supply[index] = "";
                        isOverAllNGN_2_Month = false;
                    }
                    else
                        isOverAllNGN_2_Month = true;

                    break;
                case 'N_3_MONTH':
                    if (index >= SFPGFSupplierFeedbackPartView.GetTopVisibleIndex() &&
                        index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() + (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {
                        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_3_REPLY" + index);
                        if (radioButtonList != null) {
                            // this block code (set radio button list selected index) only occur for showed page. not
                            // other page index of gridview
                            radioButtonList.SetSelectedIndex(fieldValue);
                        }

                        changeNGInput(index, fieldValue, "N_3_");
                    }

                    SFPGFSupplierFeedbackPartView.cpN3Reply[index] = fieldValue;

                    if (Number(fieldValue) !== 1) {
                        SFPGFSupplierFeedbackPartView.cpN3Plant_Cap[index] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN3Raw_Comp[index] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN3Raw_Mat[index] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN3Supply[index] = "";
                        isOverAllNGN_3_Month = false;
                    }
                    else
                        isOverAllNGN_3_Month = true;

                    break;
            }
        }

        var selectionList = [];
        selectionList[0] = SFPGFSupplierFeedbackPartView.cpNReply.join(',');
        selectionList[1] = SFPGFSupplierFeedbackPartView.cpN1Reply.join(',');
        selectionList[2] = SFPGFSupplierFeedbackPartView.cpN2Reply.join(',');
        selectionList[3] = SFPGFSupplierFeedbackPartView.cpN3Reply.join(',');
        SFPGFSupplierFeedbackPartViewSelectionLabel.SetValue(selectionList.join(';'));

        setPreviousNGData();
    }

    function OnSFPRHFNMonthOptionSelectedIndexChanged(s, e) {
        OnSFPRHFOverallCapabilityOptionSelectedIndexChanged('N_MONTH', SFPRHFNMonthOption.GetSelectedIndex());
    }

    function OnSFPRHFN1MonthOptionSelectedIndexChanged(s, e) {
        OnSFPRHFOverallCapabilityOptionSelectedIndexChanged('N_1_MONTH', SFPRHFN1MonthOption.GetSelectedIndex());
    }

    function OnSFPRHFN2MonthOptionSelectedIndexChanged(s, e) {
        OnSFPRHFOverallCapabilityOptionSelectedIndexChanged('N_2_MONTH', SFPRHFN2MonthOption.GetSelectedIndex());
    }

    function OnSFPRHFN3MonthOptionSelectedIndexChanged(s, e) {
        OnSFPRHFOverallCapabilityOptionSelectedIndexChanged('N_3_MONTH', SFPRHFN3MonthOption.GetSelectedIndex());
    }

    function OnSFPRHFCancelButtonClick(s, e) {

        isOverAllNGN_Month = false;
        isOverAllNGN_1_Month = false;
        isOverAllNGN_2_Month = false;
        isOverAllNGN_3_Month = false;

        SFPRHFNMonthOption.SetValue();
        SFPRHFN1MonthOption.SetValue();
        SFPRHFN2MonthOption.SetValue();
        SFPRHFN3MonthOption.SetValue();

        SFPGFSupplierFeedbackPartViewSelectionLabel.SetValue();

        var previousSelectionList = [];
        previousSelectionList = SFPGFSupplierFeedbackPartViewSelectionLabel.GetValue().split(';');
        if (previousSelectionList[0] != null && previousSelectionList[0] != '')
            SFPGFSupplierFeedbackPartView.cpNReply = previousSelectionList[0].split(',');
        if (previousSelectionList[1] != null && previousSelectionList[1] != '')
            SFPGFSupplierFeedbackPartView.cpN1Reply = previousSelectionList[1].split(',');
        if (previousSelectionList[2] != null && previousSelectionList[2] != '')
            SFPGFSupplierFeedbackPartView.cpN2Reply = previousSelectionList[2].split(',');
        if (previousSelectionList[3] != null && previousSelectionList[3] != '')
            SFPGFSupplierFeedbackPartView.cpN3Reply = previousSelectionList[3].split(',');

        getPreviousNGData();

        var radioButtonList = null;

        for (var index = SFPGFSupplierFeedbackPartView.cpStartIndex; index < SFPGFSupplierFeedbackPartView.cpEndIndex; index++) {
            if (index >= SFPGFSupplierFeedbackPartView.GetTopVisibleIndex() &&
                index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() +
                (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {

                radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_REPLY" + index);
                if (radioButtonList != null) {
                    radioButtonList.SetSelectedIndex(-1);
                }
                changeNGInput(index, -1, "");

                radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_1_REPLY" + index);
                if (radioButtonList != null) {
                    radioButtonList.SetSelectedIndex(-1);
                }
                changeNGInput(index, -1, "N_1_");

                radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_2_REPLY" + index);
                if (radioButtonList != null) {
                    radioButtonList.SetSelectedIndex(-1);
                }
                changeNGInput(index, -1, "N_2_");

                radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_3_REPLY" + index);
                if (radioButtonList != null) {
                    radioButtonList.SetSelectedIndex(-1);
                }
                changeNGInput(index, -1, "N_3_");
            }
            SFPGFSupplierFeedbackPartView.cpNReply[index] = -1;
            SFPGFSupplierFeedbackPartView.cpNPlant_Cap[index] = "0";
            SFPGFSupplierFeedbackPartView.cpNRaw_Comp[index] = "0";
            SFPGFSupplierFeedbackPartView.cpNRaw_Mat[index] = "0";
            SFPGFSupplierFeedbackPartView.cpNSupply[index] = "";

            SFPGFSupplierFeedbackPartView.cpN1Reply[index] = -1;
            SFPGFSupplierFeedbackPartView.cpN1Plant_Cap[index] = "0";
            SFPGFSupplierFeedbackPartView.cpN1Raw_Comp[index] = "0";
            SFPGFSupplierFeedbackPartView.cpN1Raw_Mat[index] = "0";
            SFPGFSupplierFeedbackPartView.cpN1Supply[index] = "";

            SFPGFSupplierFeedbackPartView.cpN2Reply[index] = -1;
            SFPGFSupplierFeedbackPartView.cpN2Plant_Cap[index] = "0";
            SFPGFSupplierFeedbackPartView.cpN2Raw_Comp[index] = "0";
            SFPGFSupplierFeedbackPartView.cpN2Raw_Mat[index] = "0";
            SFPGFSupplierFeedbackPartView.cpN2Supply[index] = "";

            SFPGFSupplierFeedbackPartView.cpN3Reply[index] = -1;
            SFPGFSupplierFeedbackPartView.cpN3Plant_Cap[index] = "0";
            SFPGFSupplierFeedbackPartView.cpN3Raw_Comp[index] = "0";
            SFPGFSupplierFeedbackPartView.cpN3Raw_Mat[index] = "0";
            SFPGFSupplierFeedbackPartView.cpN3Supply[index] = "";
        }

        var selectionList = [];
        selectionList[0] = SFPGFSupplierFeedbackPartView.cpNReply.join(',');
        selectionList[1] = SFPGFSupplierFeedbackPartView.cpN1Reply.join(',');
        selectionList[2] = SFPGFSupplierFeedbackPartView.cpN2Reply.join(',');
        selectionList[3] = SFPGFSupplierFeedbackPartView.cpN3Reply.join(',');

        SFPGFSupplierFeedbackPartViewSelectionLabel.SetValue(selectionList.join(';'));
        //console.log(SFPGFSupplierFeedbackPartViewSelectionLabel.GetValue());
        setPreviousNGData();
    }

    // for updating radion button value inside grid view row.

    function OnSFPGFSupplierFeedbackPartViewUpdateRow(s, e) {
        var selectionList = [];
        if (SFPGFSupplierFeedbackPartViewSelectionLabel.GetValue() == "" || SFPGFSupplierFeedbackPartViewSelectionLabel.GetValue() == null) {
            selectionList[0] = SFPGFSupplierFeedbackPartView.cpNReply.join(',');
            selectionList[1] = SFPGFSupplierFeedbackPartView.cpN1Reply.join(',');
            selectionList[2] = SFPGFSupplierFeedbackPartView.cpN2Reply.join(',');
            selectionList[3] = SFPGFSupplierFeedbackPartView.cpN3Reply.join(',');

            SFPGFSupplierFeedbackPartViewSelectionLabel.SetValue(selectionList.join(';'));
        }
        else {
            selectionList = SFPGFSupplierFeedbackPartViewSelectionLabel.GetValue().split(';');
        }

        var NGPlant_Cap = [];
        if (SFPGFSupplierFeedbackPartViewSelectionPlantCapLabel.GetValue() == "" || SFPGFSupplierFeedbackPartViewSelectionPlantCapLabel.GetValue() == null) {
            NGPlant_Cap[0] = SFPGFSupplierFeedbackPartView.cpNPlant_Cap.join(',');
            NGPlant_Cap[1] = SFPGFSupplierFeedbackPartView.cpN1Plant_Cap.join(',');
            NGPlant_Cap[2] = SFPGFSupplierFeedbackPartView.cpN2Plant_Cap.join(',');
            NGPlant_Cap[3] = SFPGFSupplierFeedbackPartView.cpN3Plant_Cap.join(',');

            SFPGFSupplierFeedbackPartViewSelectionPlantCapLabel.SetValue(NGPlant_Cap.join(';'));
        }
        else {
            NGPlant_Cap = SFPGFSupplierFeedbackPartViewSelectionPlantCapLabel.GetValue().split(';');
        }

        var NGRaw_Comp = [];
        if (SFPGFSupplierFeedbackPartViewSelectionRawCompLabel.GetValue() == "" || SFPGFSupplierFeedbackPartViewSelectionRawCompLabel.GetValue() == null) {
            NGRaw_Comp[0] = SFPGFSupplierFeedbackPartView.cpNRaw_Comp.join(',');
            NGRaw_Comp[1] = SFPGFSupplierFeedbackPartView.cpN1Raw_Comp.join(',');
            NGRaw_Comp[2] = SFPGFSupplierFeedbackPartView.cpN2Raw_Comp.join(',');
            NGRaw_Comp[3] = SFPGFSupplierFeedbackPartView.cpN3Raw_Comp.join(',');

            SFPGFSupplierFeedbackPartViewSelectionRawCompLabel.SetValue(NGRaw_Comp.join(';'));
        }
        else {
            NGRaw_Comp = SFPGFSupplierFeedbackPartViewSelectionRawCompLabel.GetValue().split(';');
        }

        var NGRaw_Mat = [];
        if (SFPGFSupplierFeedbackPartViewSelectionRawMatLabel.GetValue() == "" || SFPGFSupplierFeedbackPartViewSelectionRawMatLabel.GetValue() == null) {
            NGRaw_Mat[0] = SFPGFSupplierFeedbackPartView.cpNRaw_Mat.join(',');
            NGRaw_Mat[1] = SFPGFSupplierFeedbackPartView.cpN1Raw_Mat.join(',');
            NGRaw_Mat[2] = SFPGFSupplierFeedbackPartView.cpN2Raw_Mat.join(',');
            NGRaw_Mat[3] = SFPGFSupplierFeedbackPartView.cpN3Raw_Mat.join(',');

            SFPGFSupplierFeedbackPartViewSelectionRawMatLabel.SetValue(NGRaw_Mat.join(';'));
        }
        else {
            NGRaw_Mat = SFPGFSupplierFeedbackPartViewSelectionRawMatLabel.GetValue().split(';');
        }

        var NGSupply = [];
        if (SFPGFSupplierFeedbackPartViewSelectionSupplyLabel.GetValue() == "" || SFPGFSupplierFeedbackPartViewSelectionSupplyLabel.GetValue() == null) {
            NGSupply[0] = SFPGFSupplierFeedbackPartView.cpNSupply.join(',');
            NGSupply[1] = SFPGFSupplierFeedbackPartView.cpN1Supply.join(',');
            NGSupply[2] = SFPGFSupplierFeedbackPartView.cpN2Supply.join(',');
            NGSupply[3] = SFPGFSupplierFeedbackPartView.cpN3Supply.join(',');

            SFPGFSupplierFeedbackPartViewSelectionSupplyLabel.SetValue(NGSupply.join(';'));
        }
        else {
            NGSupply = SFPGFSupplierFeedbackPartViewSelectionSupplyLabel.GetValue().split(';');
        }

        for (var index = SFPGFSupplierFeedbackPartView.cpStartIndex; index < SFPGFSupplierFeedbackPartView.cpEndIndex; index++) {

            setInputValue(index, "", selectionList[0].split(',')[index], NGPlant_Cap[0].split(',')[index],
                          NGRaw_Comp[0].split(',')[index], NGRaw_Mat[0].split(',')[index], NGSupply[0].split(',')[index]);

            setInputValue(index, "N_1_", selectionList[1].split(',')[index], NGPlant_Cap[1].split(',')[index],
                          NGRaw_Comp[1].split(',')[index], NGRaw_Mat[1].split(',')[index], NGSupply[1].split(',')[index]);

            setInputValue(index, "N_2_", selectionList[2].split(',')[index], NGPlant_Cap[2].split(',')[index],
                          NGRaw_Comp[2].split(',')[index], NGRaw_Mat[2].split(',')[index], NGSupply[2].split(',')[index]);

            setInputValue(index, "N_3_", selectionList[3].split(',')[index], NGPlant_Cap[3].split(',')[index],
                          NGRaw_Comp[3].split(',')[index], NGRaw_Mat[3].split(',')[index], NGSupply[3].split(',')[index]);
        }
    }

    function setInputValue(index, n_month, selection, selNGPlant_Cap, selNGRaw_Comp, selNGRaw_Mat, selNGSupply) {
        var radioButtonList;
        if (index >= (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize) &&
                index < SFPGFSupplierFeedbackPartView.GetVisibleRowsOnPage() + (SFPGFSupplierFeedbackPartView.GetPageIndex() * SFPGFSupplierFeedbackPartView.cpPageSize)) {

            if (selection != null && selection != '') {

                var month_reply = n_month !== "" ? n_month.substring(2) : n_month;
                radioButtonList = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRPN_" + month_reply + "REPLY" + index);
                if (radioButtonList != null)
                    radioButtonList.SetSelectedIndex(selection);

                changeNGInput(index, selection, n_month);
            }

            if (selNGPlant_Cap != null && selNGPlant_Cap != '') {
                setCheckedNG(selNGPlant_Cap, n_month, index, "PLANT_CAP");
            }

            if (selNGRaw_Comp != null && selNGRaw_Comp != '') {
                setCheckedNG(selNGRaw_Comp, n_month, index, "RAW_COMP");
            }

            if (selNGRaw_Mat != null && selNGRaw_Mat != '') {
                setCheckedNG(selNGRaw_Mat, n_month, index, "RAW_MAT");
            }

            if (selNGSupply != null && selNGSupply != '') {
                setSupply(selNGSupply, n_month, index);
            }
        }
    }

    function setCheckedNG(value, n_month, index, fieldType) {
        var chkBox = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRP" + n_month + fieldType + index);
        if (chkBox !== null)
            chkBox.SetValue(value === "1" ? true : false);
    }

    function setSupply(value, n_month, index) {
        var setSupply = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRP" + n_month + "QTY_SUPPLY_REF" + index);
        if (setSupply !== null) {
            setSupply.SetValue(value);
        }
    }

    function setPreviousNGData() {
        var selectionList = [];

        selectionList[0] = SFPGFSupplierFeedbackPartView.cpNPlant_Cap.join(',');
        selectionList[1] = SFPGFSupplierFeedbackPartView.cpN1Plant_Cap.join(',');
        selectionList[2] = SFPGFSupplierFeedbackPartView.cpN2Plant_Cap.join(',');
        selectionList[3] = SFPGFSupplierFeedbackPartView.cpN3Plant_Cap.join(',');
        SFPGFSupplierFeedbackPartViewSelectionPlantCapLabel.SetValue(selectionList.join(';'));

        //console.log("--> " + selectionList[0]);
        //console.log(SFPGFSupplierFeedbackPartViewSelectionPlantCapLabel.GetValue());

        selectionList[0] = SFPGFSupplierFeedbackPartView.cpNRaw_Comp.join(',');
        selectionList[1] = SFPGFSupplierFeedbackPartView.cpN1Raw_Comp.join(',');
        selectionList[2] = SFPGFSupplierFeedbackPartView.cpN2Raw_Comp.join(',');
        selectionList[3] = SFPGFSupplierFeedbackPartView.cpN3Raw_Comp.join(',');
        SFPGFSupplierFeedbackPartViewSelectionRawCompLabel.SetValue(selectionList.join(';'));

        selectionList[0] = SFPGFSupplierFeedbackPartView.cpNRaw_Mat.join(',');
        selectionList[1] = SFPGFSupplierFeedbackPartView.cpN1Raw_Mat.join(',');
        selectionList[2] = SFPGFSupplierFeedbackPartView.cpN2Raw_Mat.join(',');
        selectionList[3] = SFPGFSupplierFeedbackPartView.cpN3Raw_Mat.join(',');
        SFPGFSupplierFeedbackPartViewSelectionRawMatLabel.SetValue(selectionList.join(';'));

        selectionList[0] = SFPGFSupplierFeedbackPartView.cpNSupply.join(',');
        selectionList[1] = SFPGFSupplierFeedbackPartView.cpN1Supply.join(',');
        selectionList[2] = SFPGFSupplierFeedbackPartView.cpN2Supply.join(',');
        selectionList[3] = SFPGFSupplierFeedbackPartView.cpN3Supply.join(',');
        SFPGFSupplierFeedbackPartViewSelectionSupplyLabel.SetValue(selectionList.join(';'));
    }

    function getPreviousNGData() {
        //Get Previous NG Factor data
        var prevNGPlant_Cap = []
        prevNGPlant_Cap = SFPGFSupplierFeedbackPartViewSelectionPlantCapLabel.GetValue().split(';');
        if (prevNGPlant_Cap[0] != null && prevNGPlant_Cap[0] != '')
            SFPGFSupplierFeedbackPartView.cpNPlant_Cap = prevNGPlant_Cap[0].split(',');
        if (prevNGPlant_Cap[1] != null && prevNGPlant_Cap[1] != '')
            SFPGFSupplierFeedbackPartView.cpN1Plant_Cap = prevNGPlant_Cap[1].split(',');
        if (prevNGPlant_Cap[2] != null && prevNGPlant_Cap[2] != '')
            SFPGFSupplierFeedbackPartView.cpN2Plant_Cap = prevNGPlant_Cap[2].split(',');
        if (prevNGPlant_Cap[3] != null && prevNGPlant_Cap[3] != '')
            SFPGFSupplierFeedbackPartView.cpN3Plant_Cap = prevNGPlant_Cap[3].split(',');

        //Get Previous NG Factor data for : Raw Comp
        var prevNGRaw_Comp = []
        prevNGRaw_Comp = SFPGFSupplierFeedbackPartViewSelectionRawCompLabel.GetValue().split(';');
        if (prevNGRaw_Comp[0] != null && prevNGRaw_Comp[0] != '')
            SFPGFSupplierFeedbackPartView.cpNRaw_Comp = prevNGRaw_Comp[0].split(',');
        if (prevNGRaw_Comp[1] != null && prevNGRaw_Comp[1] != '')
            SFPGFSupplierFeedbackPartView.cpN1Raw_Comp = prevNGRaw_Comp[1].split(',');
        if (prevNGRaw_Comp[2] != null && prevNGRaw_Comp[2] != '')
            SFPGFSupplierFeedbackPartView.cpN2Raw_Comp = prevNGRaw_Comp[2].split(',');
        if (prevNGRaw_Comp[3] != null && prevNGRaw_Comp[3] != '')
            SFPGFSupplierFeedbackPartView.cpN3Raw_Comp = prevNGRaw_Comp[3].split(',');

        //Get Previous NG Factor data for : Raw Mat
        var prevNGRaw_Mat = []
        prevNGRaw_Mat = SFPGFSupplierFeedbackPartViewSelectionRawMatLabel.GetValue().split(';');
        if (prevNGRaw_Mat[0] != null && prevNGRaw_Mat[0] != '')
            SFPGFSupplierFeedbackPartView.cpNRaw_Mat = prevNGRaw_Mat[0].split(',');
        if (prevNGRaw_Mat[1] != null && prevNGRaw_Mat[1] != '')
            SFPGFSupplierFeedbackPartView.cpN1Raw_Mat = prevNGRaw_Mat[1].split(',');
        if (prevNGRaw_Mat[2] != null && prevNGRaw_Mat[2] != '')
            SFPGFSupplierFeedbackPartView.cpN2Raw_Mat = prevNGRaw_Mat[2].split(',');
        if (prevNGRaw_Mat[3] != null && prevNGRaw_Mat[3] != '')
            SFPGFSupplierFeedbackPartView.cpN3Raw_Mat = prevNGRaw_Mat[3].split(',');

        //Get Previous NG Factor data for : Raw Mat
        var prevNGSupply = []
        prevNGSupply = SFPGFSupplierFeedbackPartViewSelectionSupplyLabel.GetValue().split(';');
        if (prevNGSupply[0] != null && prevNGSupply[0] != '')
            SFPGFSupplierFeedbackPartView.cpNSupply = prevNGSupply[0].split(',');
        if (prevNGSupply[1] != null && prevNGSupply[1] != '')
            SFPGFSupplierFeedbackPartView.cpN1Supply = prevNGSupply[1].split(',');
        if (prevNGSupply[2] != null && prevNGSupply[2] != '')
            SFPGFSupplierFeedbackPartView.cpN2Supply = prevNGSupply[2].split(',');
        if (prevNGSupply[3] != null && prevNGSupply[3] != '')
            SFPGFSupplierFeedbackPartView.cpN3Supply = prevNGSupply[3].split(',');
    }

    function changeNGInput(index, n_reply_value, n_month) {
        var chkBoxPlantCap = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRP" + n_month + "PLANT_CAP" + index);
        var chkBoxRawComp = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRP" + n_month + "RAW_COMP" + index);
        var chkBoxRawMat = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRP" + n_month + "RAW_MAT" + index);
        var txtSupply = ASPxClientControl.GetControlCollection().GetByName("SFPGFGRP" + n_month + "QTY_SUPPLY_REF" + index);

        if (Number(n_reply_value) === 1) {

            if (chkBoxPlantCap !== null) {
                chkBoxPlantCap.ChangeEnabledAttributes(true);
                chkBoxPlantCap.clientEnabled = true;
            }

            if (chkBoxRawComp !== null) {
                chkBoxRawComp.ChangeEnabledAttributes(true);
                chkBoxRawComp.clientEnabled = true;
            }

            if (chkBoxRawMat !== null) {
                chkBoxRawMat.ChangeEnabledAttributes(true);
                chkBoxRawMat.clientEnabled = true;
            }

            if (txtSupply !== null) {
                txtSupply.clientEnabled = true;
                txtSupply.ChangeEnabledAttributes(true);
                txtSupply.ChangeEnabledStateItems(true);

                $("#SFPGFGRP" + n_month + "QTY_SUPPLY_REF" + index).css("background-color", "white");
                $("#SFPGFGRP" + n_month + "QTY_SUPPLY_REF" + index + "_I").css("color", "black");
                $("#SFPGFGRP" + n_month + "QTY_SUPPLY_REF" + index + "_I").css("background-color", "white");
            }
        }
        else {
            if (chkBoxPlantCap !== null) {
                chkBoxPlantCap.ChangeEnabledAttributes(false);
                chkBoxPlantCap.SetValue(false);
            }

            if (chkBoxRawComp !== null) {
                chkBoxRawComp.ChangeEnabledAttributes(false);
                chkBoxRawComp.SetValue(false);
            }

            if (chkBoxRawMat !== null) {
                chkBoxRawMat.ChangeEnabledAttributes(false);
                chkBoxRawMat.SetValue(false);
            }

            if (txtSupply !== null) {
                txtSupply.clientEnabled = false;
                txtSupply.ChangeEnabledAttributes(false);
                txtSupply.ChangeEnabledStateItems(false);

                $("#SFPGFGRP" + n_month + "QTY_SUPPLY_REF" + index).css("background-color", "#ECE6E6");
                $("#SFPGFGRP" + n_month + "QTY_SUPPLY_REF" + index + "_I").css("color", "black");
                $("#SFPGFGRP" + n_month + "QTY_SUPPLY_REF" + index + "_I").css("background-color", "#ECE6E6");

                txtSupply.SetValue("");
            }
        }
    }

    function OnSFPGFGRPREPLYSelectedIndexChanged(fieldIndex, fieldName, fieldValue, fieldPropName) {
        // get previous stored radio button list sellection list.
        var previousSelectionList = [];
        previousSelectionList = SFPGFSupplierFeedbackPartViewSelectionLabel.GetValue().split(';');
        if (previousSelectionList[0] != null && previousSelectionList[0] != '')
            SFPGFSupplierFeedbackPartView.cpNReply = previousSelectionList[0].split(',');
        if (previousSelectionList[1] != null && previousSelectionList[1] != '')
            SFPGFSupplierFeedbackPartView.cpN1Reply = previousSelectionList[1].split(',');
        if (previousSelectionList[2] != null && previousSelectionList[2] != '')
            SFPGFSupplierFeedbackPartView.cpN2Reply = previousSelectionList[2].split(',');
        if (previousSelectionList[3] != null && previousSelectionList[3] != '')
            SFPGFSupplierFeedbackPartView.cpN3Reply = previousSelectionList[3].split(',');

        getPreviousNGData();

        switch (fieldName) {
            case 'N_MONTH':
                if (fieldPropName === "REPLY") {
                    SFPGFSupplierFeedbackPartView.cpNReply[fieldIndex] = fieldValue;

                    if (Number(fieldValue) === 0) {
                        SFPGFSupplierFeedbackPartView.cpNPlant_Cap[fieldIndex] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpNRaw_Comp[fieldIndex] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpNRaw_Mat[fieldIndex] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpNSupply[fieldIndex] = "";
                    }

                    changeNGInput(fieldIndex, fieldValue, "");
                }

                if (fieldPropName === "PLANT_CAP") {
                    SFPGFSupplierFeedbackPartView.cpNPlant_Cap[fieldIndex] = fieldValue;
                }

                if (fieldPropName === "RAW_COMP") {
                    SFPGFSupplierFeedbackPartView.cpNRaw_Comp[fieldIndex] = fieldValue;
                }

                if (fieldPropName === "RAW_MAT") {
                    SFPGFSupplierFeedbackPartView.cpNRaw_Mat[fieldIndex] = fieldValue;
                }

                if (fieldPropName === "QTY_SUPPLY") {
                    SFPGFSupplierFeedbackPartView.cpNSupply[fieldIndex] = fieldValue;
                }

                break;
            case 'N_1_MONTH':

                if (fieldPropName === "REPLY") {
                    SFPGFSupplierFeedbackPartView.cpN1Reply[fieldIndex] = fieldValue;

                    if (Number(fieldValue) === 0) {
                        SFPGFSupplierFeedbackPartView.cpN1Plant_Cap[fieldIndex] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN1Raw_Comp[fieldIndex] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN1Raw_Mat[fieldIndex] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN1Supply[fieldIndex] = "";
                    }

                    changeNGInput(fieldIndex, fieldValue, "N_1_");
                }

                if (fieldPropName === "PLANT_CAP") {
                    SFPGFSupplierFeedbackPartView.cpN1Plant_Cap[fieldIndex] = fieldValue;
                }

                if (fieldPropName === "RAW_COMP") {
                    SFPGFSupplierFeedbackPartView.cpN1Raw_Comp[fieldIndex] = fieldValue;
                }

                if (fieldPropName === "RAW_MAT") {
                    SFPGFSupplierFeedbackPartView.cpN1Raw_Mat[fieldIndex] = fieldValue;
                }

                if (fieldPropName === "QTY_SUPPLY") {
                    SFPGFSupplierFeedbackPartView.cpN1Supply[fieldIndex] = fieldValue;
                }

                break;
            case 'N_2_MONTH':
                if (fieldPropName === "REPLY") {
                    SFPGFSupplierFeedbackPartView.cpN2Reply[fieldIndex] = fieldValue;

                    if (Number(fieldValue) === 0) {
                        SFPGFSupplierFeedbackPartView.cpN2Plant_Cap[fieldIndex] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN2Raw_Comp[fieldIndex] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN2Raw_Mat[fieldIndex] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN2Supply[fieldIndex] = "";
                    }

                    changeNGInput(fieldIndex, fieldValue, "N_2_");
                }

                if (fieldPropName === "PLANT_CAP") {
                    SFPGFSupplierFeedbackPartView.cpN2Plant_Cap[fieldIndex] = fieldValue;
                }

                if (fieldPropName === "RAW_COMP") {
                    SFPGFSupplierFeedbackPartView.cpN2Raw_Comp[fieldIndex] = fieldValue;
                }

                if (fieldPropName === "RAW_MAT") {
                    SFPGFSupplierFeedbackPartView.cpN2Raw_Mat[fieldIndex] = fieldValue;
                }

                if (fieldPropName === "QTY_SUPPLY") {
                    SFPGFSupplierFeedbackPartView.cpN2Supply[fieldIndex] = fieldValue;
                }

                break;
            case 'N_3_MONTH':
                if (fieldPropName === "REPLY") {
                    SFPGFSupplierFeedbackPartView.cpN3Reply[fieldIndex] = fieldValue;

                    if (Number(fieldValue) === 0) {
                        SFPGFSupplierFeedbackPartView.cpN3Plant_Cap[fieldIndex] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN3Raw_Comp[fieldIndex] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN3Raw_Mat[fieldIndex] = fieldValue;
                        SFPGFSupplierFeedbackPartView.cpN3Supply[fieldIndex] = "";
                    }

                    changeNGInput(fieldIndex, fieldValue, "N_3_");
                }

                if (fieldPropName === "PLANT_CAP") {
                    SFPGFSupplierFeedbackPartView.cpN3Plant_Cap[fieldIndex] = fieldValue;
                }

                if (fieldPropName === "RAW_COMP") {
                    SFPGFSupplierFeedbackPartView.cpN3Raw_Comp[fieldIndex] = fieldValue;
                }

                if (fieldPropName === "RAW_MAT") {
                    SFPGFSupplierFeedbackPartView.cpN3Raw_Mat[fieldIndex] = fieldValue;
                }

                if (fieldPropName === "QTY_SUPPLY") {
                    SFPGFSupplierFeedbackPartView.cpN3Supply[fieldIndex] = fieldValue;
                }

                break;
        }

        var selectionList = [];
        selectionList[0] = SFPGFSupplierFeedbackPartView.cpNReply.join(',');
        selectionList[1] = SFPGFSupplierFeedbackPartView.cpN1Reply.join(',');
        selectionList[2] = SFPGFSupplierFeedbackPartView.cpN2Reply.join(',');
        selectionList[3] = SFPGFSupplierFeedbackPartView.cpN3Reply.join(',');

        SFPGFSupplierFeedbackPartViewSelectionLabel.SetValue(selectionList.join(';'));

        setPreviousNGData();
    }

    //Adding Client Control for Get NG Data by FID.Reggy
    function OnSFPGFGRPNGSelectedIndexChanged(fieldName, value, n_month, fieldType) {

        var index;
        var subindex = n_month !== "N_MONTH" ? 4 : 0;
        switch (fieldType) {
            case "PLANT_CAP":
                index = fieldName.substring(17 + subindex);
                break;
            case "RAW_COMP":
                index = fieldName.substring(16 + subindex);
                break;
            case "RAW_MAT":
                index = fieldName.substring(15 + subindex);
                break;
        }
        var stringvalue = value == true ? "1" : "0"
        OnSFPGFGRPREPLYSelectedIndexChanged(index, n_month, stringvalue, fieldType);
    }

    function OnSFPGFGRPNGTextChanged(fieldName, value, n_month, fieldType) {

        var subindex = n_month !== "N_MONTH" ? 4 : 0;
        var index = fieldName.substring(22 + subindex);

        //alert(subindex + " - " + index + " - " + value + " - " + fieldType);
        //return;

        OnSFPGFGRPREPLYSelectedIndexChanged(index, n_month, value, fieldType);
    }
    //End Adding Client Control for Get NG Data

    function OnSFPGFGRPN_REPLYSelectedIndexChanged(s, e) {
        var index = s.name.substring(15);
        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName(s.name);
        OnSFPGFGRPREPLYSelectedIndexChanged(index, 'N_MONTH', radioButtonList.GetSelectedIndex(), "REPLY");
    }

    function OnSFPGFGRPN_1_REPLYSelectedIndexChanged(s, e) {
        var index = s.name.substring(17);
        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName(s.name);
        OnSFPGFGRPREPLYSelectedIndexChanged(index, 'N_1_MONTH', radioButtonList.GetSelectedIndex(), "REPLY");
    }

    function OnSFPGFGRPN_2_REPLYSelectedIndexChanged(s, e) {
        var index = s.name.substring(17);
        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName(s.name);
        OnSFPGFGRPREPLYSelectedIndexChanged(index, 'N_2_MONTH', radioButtonList.GetSelectedIndex(), "REPLY");
    }

    function OnSFPGFGRPN_3_REPLYSelectedIndexChanged(s, e) {
        var index = s.name.substring(17);
        var radioButtonList = ASPxClientControl.GetControlCollection().GetByName(s.name);
        OnSFPGFGRPREPLYSelectedIndexChanged(index, 'N_3_MONTH', radioButtonList.GetSelectedIndex(), "REPLY");
    }

    function OnSFPGFSupplierFeedbackPartViewEndCallback(s, e) {
        OnSFPGFSupplierFeedbackPartViewUpdateRow();
    }

    function OnSFPGFSupplierFeedbackPartViewBeginCallback(s, e) {

        e.customArgs["ProductionMonth"] = productionMonth;
        e.customArgs["SupplierCode"] = supplierCode;
        e.customArgs["SupplierPlanCode"] = supplierPlanCode;
        e.customArgs["Version"] = version;
        e.customArgs["Lock"] = lock;
        e.customArgs["FilePath"] = filePath;

        filePath = "";
    }

    function OnFDLPOPTFeedbackReplyLinkClick(s, e, boardName) {
        var index = s.name.substring(25);

        index = index - (ForecastDetailView.GetPageIndex() * ForecastDetailView.cpPageSize);

        productionMonth = ForecastDetailView.cpProductionMonth[index];
        supplierCode = ForecastDetailView.cpSupplierCd[index];
        supplierPlanCode = ForecastDetailView.cpSupplierPlant[index];
        tlock = ForecastDetailView.cpTLockStatus[index];
        lock = tlock;

        version = 'T';

        $.ajax({
            url: "@Url.Content("~/Forecast/_ajax_CacheUpcomingMessageBoardName")",
            data: {
                boardName: boardName
            },
            success: function (data) {
                popupFeedbackPart.Show();
            }
        });
    }

    function OnFDLPOPFFeedbackReplyLinkClick(s, e, boardName) {
        var index = s.name.substring(25);

        index = index - (ForecastDetailView.GetPageIndex() * ForecastDetailView.cpPageSize);

        productionMonth = ForecastDetailView.cpProductionMonth[index];
        supplierCode = ForecastDetailView.cpSupplierCd[index];
        supplierPlanCode = ForecastDetailView.cpSupplierPlant[index];
        flock = ForecastDetailView.cpFLockStatus[index];
        lock = flock;
        version = 'F';

        $.ajax({
            url: "@Url.Content("~/Forecast/_ajax_CacheUpcomingMessageBoardName")",
            data: {
                boardName: boardName
            },
            success: function (data) {
                popupFeedbackPart.Show();
            }
        });
    }

    function OnPopupFeedbackPartShown(s, e) {
        popupFeedbackPart.SetHeaderText("Monthly Forecast : " + GetRegularProductionMonth(productionMonth));
        popupFeedbackPart.PerformCallback();

        setTimeout(function () {
            OnSFPRHFCancelButtonClick();
        }, 1000);
    }

    function OnSFPFFFileUploadFileUploadComplete(s, e) {
        if (e.isValid) {
            filePath = e.callbackData;

            $("#SFPGUPMessageLabel").text("Upload in progress,\nPlease wait...");
            popupFeedbackPartGridUploadProgress.Show();

            $.ajax({
                type: "POST",
                url: "@Url.Content("~/SupplierFeedbackPart/PartialGridSupplierFeedbackPartForecast_Upload")",
                dataType: "json",
                data: {
                    productionMonth: productionMonth
                    , supplierCode: supplierCode
                    , supplierPlanCode: supplierPlanCode
                    , version: version
                    , filePath: filePath
                },
                success: function (result) {
                    $("#SupplierFeedbackPartGridPartial_Forecast").html(result.View);

                    var parameterValues = result.Status.split(';');
                    if (parameterValues[0] == "true") {
                        popupFeedbackPartGridUploadProgress.Hide();
                        isUpload = true;
                        // clear temporary upload data
                        OnSFPFFFileUploadFileUploadCleared(parameterValues[1], parameterValues[2], parameterValues[3], parameterValues[4]);
                        OnSFPGFUCOkButtonClick();
                    }
                    else if (parameterValues[0] == "false") {
                        OnSFPFFFileUploadFileUploadInvalid(parameterValues[1], parameterValues[2], parameterValues[3], parameterValues[4]);
                        popupFeedbackPart.PerformCallback();
                    }
                    else if (parameterValues[0] == "invalid") {
                        popupFeedbackPartGridUploadProgress.Hide();
                        alert("Upload invalid.");
                        popupFeedbackPart.PerformCallback();
                    }
                    else if (parameterValues[0] == "notmatch") {
                        popupFeedbackPartGridUploadProgress.Hide();
                        alert("Cannot Upload Data Partially");
                        popupFeedbackPart.PerformCallback();
                    }
                },
                error: function (result) {
                    popupFeedbackPartGridUploadProgress.Hide();

                    alert("Error On Upload Supplier Feedback Part Data.");
                }
            });

        }
        else {
            popupFeedbackPartGridUploadProgress.Hide();
            popupFeedbackPart.PerformCallback();

            alert("Upload invalid.");
        }
    }

    function OnSFPFFFileUploadFileUploadInvalid(processId, functionId, temporaryTableUpload, temporaryTableValidate) {
        $("#SFPGUPMessageLabel").text("Upload invalid,\nPlease wait...");

        $.fileDownload("SupplierFeedbackPart/DownloadInvalid/", {
            httpMethod: "GET",
            data: {
                productionMonth: productionMonth,
                supplierCode: supplierCode,
                supplierPlanCode: supplierPlanCode,
                version: version,
                processId: processId,
                functionId: functionId
            },
            successCallback: function (responseHtml, url) {
                popupFeedbackPartGridUploadProgress.Hide();

                // clear temporary upload data
                OnSFPFFFileUploadFileUploadCleared(processId, functionId, temporaryTableUpload, temporaryTableValidate);
            },
            failCallback: function (responseHtml, url) {
                popupFeedbackPartGridUploadProgress.Hide();

                alert("Error On Download Supplier Feedback Part Invalid Data.");
            }
        });
    }

    function OnSFPFFFileUploadFileUploadCleared(processId, functionId, temporaryTableUpload, temporaryTableValidate) {
        $.ajax({
            type: "POST",
            url: "@Url.Content("~/SupplierFeedbackPart/ClearAllFeedbackPartUpload")",
            data: {
                processId: processId,
                functionId: functionId,
                temporaryTableUpload: temporaryTableUpload,
                temporaryTableValidate: temporaryTableValidate
            },
            success: function (result) {

            },
            error: function (result) {
                alert("Error On Clear Supplier Feedback Part Upload Data.");
            }
        });
    }

    function OnSFPFFUploadButtonClick(s, e) {
        popupFeedbackPartGridUploadConfirmation.Show();
    }

    function OnSFPRHFOkButtonClick(s, e) {
        OnFFPConfirmButtonClick();
    }

    function OnFFPConfirmButtonClick(s, e) {
        popupFeedbackPartGridUpdateConfirmation.Show();
    }

    function OnSFPGFUCOkButtonClick(s, e) {
        popupFeedbackPartGridUpdateConfirmation.Hide();

        $("#SFPGUPPMessageLabel").text("Update in progress,\nPlease wait...");
        popupFeedbackPartGridUpdateProgress.Show();

        var Feedback = [];

        parameterList = "";
        var isValid = true;
        var isEvidenceRequired = false;
        var isErrorN = false, isSuccessN = false;
        var isErrorN1 = false, isSuccessN1 = false;
        var isErrorN2 = false, isSuccessN2 = false;
        var isErrorN3 = false, isSuccessN3 = false;
        var isErrorSupplyN = false, isSuccessSupplyN = true;
        var isErrorSupplyN1 = false, isSuccessSupplyN1 = true;
        var isErrorSupplyN2 = false, isSuccessSupplyN2 = true;
        var isErrorSupplyN3 = false, isSuccessSupplyN3 = true;

        // get previous stored radio button list sellection list.
        if (!isUpload) {
            var previousSelectionList = [];
            previousSelectionList = SFPGFSupplierFeedbackPartViewSelectionLabel.GetValue().split(';');
            if (previousSelectionList[0] != null && previousSelectionList[0] != '')
                SFPGFSupplierFeedbackPartView.cpNReply = previousSelectionList[0].split(',');
            if (previousSelectionList[1] != null && previousSelectionList[1] != '')
                SFPGFSupplierFeedbackPartView.cpN1Reply = previousSelectionList[1].split(',');
            if (previousSelectionList[2] != null && previousSelectionList[2] != '')
                SFPGFSupplierFeedbackPartView.cpN2Reply = previousSelectionList[2].split(',');
            if (previousSelectionList[3] != null && previousSelectionList[3] != '')
                SFPGFSupplierFeedbackPartView.cpN3Reply = previousSelectionList[3].split(',');
        }

        for (var index = SFPGFSupplierFeedbackPartView.cpStartIndex; index < SFPGFSupplierFeedbackPartView.cpEndIndex; index++) {

            if (((SFPGFSupplierFeedbackPartView.cpNReply[index] != '0') && (SFPGFSupplierFeedbackPartView.cpNReply[index] != '1')) ||
		        ((SFPGFSupplierFeedbackPartView.cpN1Reply[index] != '0') && (SFPGFSupplierFeedbackPartView.cpN1Reply[index] != '1')) ||
		        ((SFPGFSupplierFeedbackPartView.cpN2Reply[index] != '0') && (SFPGFSupplierFeedbackPartView.cpN2Reply[index] != '1')) ||
		        ((SFPGFSupplierFeedbackPartView.cpN3Reply[index] != '0') && (SFPGFSupplierFeedbackPartView.cpN3Reply[index] != '1'))) {
                isValid = false;
            }

            if (isOverAllNGN_Month) {
                if ((SFPGFSupplierFeedbackPartView.cpNReply[index] == '1' || SFPGFSupplierFeedbackPartView.cpNReply[index] == true)
                   && ((Number(SFPGFSupplierFeedbackPartView.cpNPlant_Cap[index]) !== 0)
                        || (Number(SFPGFSupplierFeedbackPartView.cpNRaw_Comp[index]) !== 0)
                        || (Number(SFPGFSupplierFeedbackPartView.cpNRaw_Mat[index]) !== 0))) {
                    isSuccessN = true;
                }
            }
            else {
                if ((SFPGFSupplierFeedbackPartView.cpNReply[index] == '1' || SFPGFSupplierFeedbackPartView.cpNReply[index] == true)
                    && ((Number(SFPGFSupplierFeedbackPartView.cpNPlant_Cap[index]) === 0)
                        && (Number(SFPGFSupplierFeedbackPartView.cpNRaw_Comp[index]) === 0)
                        && (Number(SFPGFSupplierFeedbackPartView.cpNRaw_Mat[index]) === 0))) {
                    isErrorN = true;
                }
            }

            if (isOverAllNGN_1_Month) {
                if ((SFPGFSupplierFeedbackPartView.cpN1Reply[index] == '1' || SFPGFSupplierFeedbackPartView.cpN1Reply[index] == true)
                   && ((Number(SFPGFSupplierFeedbackPartView.cpN1Plant_Cap[index]) !== 0)
                        || (Number(SFPGFSupplierFeedbackPartView.cpN1Raw_Comp[index]) !== 0)
                        || (Number(SFPGFSupplierFeedbackPartView.cpN1Raw_Mat[index]) !== 0))) {
                    isSuccessN1 = true;
                }
            }
            else {
                if ((SFPGFSupplierFeedbackPartView.cpN1Reply[index] == '1' || SFPGFSupplierFeedbackPartView.cpN1Reply[index] == true)
                    && ((Number(SFPGFSupplierFeedbackPartView.cpN1Plant_Cap[index]) === 0)
                        && (Number(SFPGFSupplierFeedbackPartView.cpN1Raw_Comp[index]) === 0)
                        && (Number(SFPGFSupplierFeedbackPartView.cpN1Raw_Mat[index]) === 0))) {
                    isErrorN1 = true;
                }
            }

            if (isOverAllNGN_2_Month) {
                if ((SFPGFSupplierFeedbackPartView.cpN1Reply[index] == '1' || SFPGFSupplierFeedbackPartView.cpN2Reply[index] == true)
                   && ((Number(SFPGFSupplierFeedbackPartView.cpN2Plant_Cap[index]) !== 0)
                        || (Number(SFPGFSupplierFeedbackPartView.cpN2Raw_Comp[index]) !== 0)
                        || (Number(SFPGFSupplierFeedbackPartView.cpN2Raw_Mat[index]) !== 0))) {
                    isSuccessN2 = true;
                }
            }
            else {
                if ((SFPGFSupplierFeedbackPartView.cpN2Reply[index] == '1' || SFPGFSupplierFeedbackPartView.cpN2Reply[index] == true)
                    && ((Number(SFPGFSupplierFeedbackPartView.cpN2Plant_Cap[index]) === 0)
                        && (Number(SFPGFSupplierFeedbackPartView.cpN2Raw_Comp[index]) === 0)
                        && (Number(SFPGFSupplierFeedbackPartView.cpN2Raw_Mat[index]) === 0))) {
                    isErrorN2 = true;
                }
            }

            if (isOverAllNGN_3_Month) {
                if ((SFPGFSupplierFeedbackPartView.cpN3Reply[index] == '1' || SFPGFSupplierFeedbackPartView.cpN3Reply[index] == true)
                   && ((Number(SFPGFSupplierFeedbackPartView.cpN3Plant_Cap[index]) !== 0)
                        || (Number(SFPGFSupplierFeedbackPartView.cpN3Raw_Comp[index]) !== 0)
                        || (Number(SFPGFSupplierFeedbackPartView.cpN3Raw_Mat[index]) !== 0))) {
                    isSuccessN3 = true;
                }
            }
            else {
                if ((SFPGFSupplierFeedbackPartView.cpN3Reply[index] == '1' || SFPGFSupplierFeedbackPartView.cpN3Reply[index] == true)
                    && ((Number(SFPGFSupplierFeedbackPartView.cpN3Plant_Cap[index]) === 0)
                        && (Number(SFPGFSupplierFeedbackPartView.cpN3Raw_Comp[index]) === 0)
                        && (Number(SFPGFSupplierFeedbackPartView.cpN3Raw_Mat[index]) === 0))) {
                    isErrorN3 = true;
                }
            }

            if (SFPGFSupplierFeedbackPartView.cpNReply[index] == true)
                SFPGFSupplierFeedbackPartView.cpNReply[index] = '1';
            else if (SFPGFSupplierFeedbackPartView.cpNReply[index] == false)
                SFPGFSupplierFeedbackPartView.cpNReply[index] = '0';
            //else
            //    SFPGFSupplierFeedbackPartView.cpNReply[index] = '-1';

            if (SFPGFSupplierFeedbackPartView.cpN1Reply[index] == true)
                SFPGFSupplierFeedbackPartView.cpN1Reply[index] = '1';
            else if (SFPGFSupplierFeedbackPartView.cpN1Reply[index] == false)
                SFPGFSupplierFeedbackPartView.cpN1Reply[index] = '0';
            //else
            //    SFPGFSupplierFeedbackPartView.cpN1Reply[index] = '-1';

            if (SFPGFSupplierFeedbackPartView.cpN2Reply[index] == true)
                SFPGFSupplierFeedbackPartView.cpN2Reply[index] = '1';
            else if (SFPGFSupplierFeedbackPartView.cpN2Reply[index] == false)
                SFPGFSupplierFeedbackPartView.cpN2Reply[index] = '0';
            //else
            //    SFPGFSupplierFeedbackPartView.cpN2Reply[index] = '-1';

            if (SFPGFSupplierFeedbackPartView.cpN3Reply[index] == true)
                SFPGFSupplierFeedbackPartView.cpN3Reply[index] = '1';
            else if (SFPGFSupplierFeedbackPartView.cpN3Reply[index] == false)
                SFPGFSupplierFeedbackPartView.cpN3Reply[index] = '0';
            //else
            //    SFPGFSupplierFeedbackPartView.cpN3Reply[index] = '-1';

            Feedback[index] = {
                D_ID: SFPGFSupplierFeedbackPartView.cpDID[index],
                DOCK_CD: SFPGFSupplierFeedbackPartView.cpDockCd[index],
                PART_NO: SFPGFSupplierFeedbackPartView.cpPartNo[index],
                PACK_MONTH: SFPGFSupplierFeedbackPartView.cpPackMonth[index],
                SUPPLIER_CD: SFPGFSupplierFeedbackPartView.cpSupplierCd[index],
                S_PLANT_CD: SFPGFSupplierFeedbackPartView.cpSPlantCd[index],
                VERS: SFPGFSupplierFeedbackPartView.cpVers[index],
                N_VOLUME: SFPGFSupplierFeedbackPartView.cpNVolume[index],
                N_1_VOLUME: SFPGFSupplierFeedbackPartView.cpN1Volume[index],
                N_2_VOLUME: SFPGFSupplierFeedbackPartView.cpN2Volume[index],
                N_3_VOLUME: SFPGFSupplierFeedbackPartView.cpN3Volume[index],
                N_FA: SFPGFSupplierFeedbackPartView.cpNFA[index],
                N_1_FA: SFPGFSupplierFeedbackPartView.cpN1FA[index],
                N_2_FA: SFPGFSupplierFeedbackPartView.cpN2FA[index],
                N_3_FA: SFPGFSupplierFeedbackPartView.cpN3FA[index],
                N_MONTH: SFPGFSupplierFeedbackPartView.cpNReply[index],
                N_1_MONTH: SFPGFSupplierFeedbackPartView.cpN1Reply[index],
                N_2_MONTH: SFPGFSupplierFeedbackPartView.cpN2Reply[index],
                N_3_MONTH: SFPGFSupplierFeedbackPartView.cpN3Reply[index],
                NOTICE: SFPGFSupplierFeedbackPartView.cpNotice[index],
                N_REPLY_PLANT_CAP: SFPGFSupplierFeedbackPartView.cpNPlant_Cap[index],
                N_1_REPLY_PLANT_CAP: SFPGFSupplierFeedbackPartView.cpN1Plant_Cap[index],
                N_2_REPLY_PLANT_CAP: SFPGFSupplierFeedbackPartView.cpN2Plant_Cap[index],
                N_3_REPLY_PLANT_CAP: SFPGFSupplierFeedbackPartView.cpN3Plant_Cap[index],
                N_REPLY_RAW_COMP: SFPGFSupplierFeedbackPartView.cpNRaw_Comp[index],
                N_1_REPLY_RAW_COMP: SFPGFSupplierFeedbackPartView.cpN1Raw_Comp[index],
                N_2_REPLY_RAW_COMP: SFPGFSupplierFeedbackPartView.cpN2Raw_Comp[index],
                N_3_REPLY_RAW_COMP: SFPGFSupplierFeedbackPartView.cpN3Raw_Comp[index],
                N_REPLY_RAW_MAT: SFPGFSupplierFeedbackPartView.cpNRaw_Mat[index],
                N_1_REPLY_RAW_MAT: SFPGFSupplierFeedbackPartView.cpN1Raw_Mat[index],
                N_2_REPLY_RAW_MAT: SFPGFSupplierFeedbackPartView.cpN2Raw_Mat[index],
                N_3_REPLY_RAW_MAT: SFPGFSupplierFeedbackPartView.cpN3Raw_Mat[index],
                N_REPLY_QTY_SUPPLY_REFF: SFPGFSupplierFeedbackPartView.cpNSupply[index],
                N_1_REPLY_QTY_SUPPLY_REFF: SFPGFSupplierFeedbackPartView.cpN1Supply[index],
                N_2_REPLY_QTY_SUPPLY_REFF: SFPGFSupplierFeedbackPartView.cpN2Supply[index],
                N_3_REPLY_QTY_SUPPLY_REFF: SFPGFSupplierFeedbackPartView.cpN3Supply[index]
            };

            if ((Number(SFPGFSupplierFeedbackPartView.cpNPlant_Cap[index]) !== 0)
	               || (Number(SFPGFSupplierFeedbackPartView.cpNRaw_Comp[index]) !== 0)
	               || (Number(SFPGFSupplierFeedbackPartView.cpNRaw_Mat[index]) !== 0)) {

                if ((Number(SFPGFSupplierFeedbackPartView.cpNSupply[index]) < 0)
                    || (SFPGFSupplierFeedbackPartView.cpNSupply[index] == ''))
                    isErrorSupplyN = true;
            }

            if ((Number(SFPGFSupplierFeedbackPartView.cpN1Plant_Cap[index]) !== 0)
                   || (Number(SFPGFSupplierFeedbackPartView.cpN1Raw_Comp[index]) !== 0)
                   || (Number(SFPGFSupplierFeedbackPartView.cpN1Raw_Mat[index]) !== 0)) {

                if ((Number(SFPGFSupplierFeedbackPartView.cpN1Supply[index]) < 0)
                    || (SFPGFSupplierFeedbackPartView.cpN1Supply[index] == ''))
                    isErrorSupplyN1 = true;
            }

            if ((Number(SFPGFSupplierFeedbackPartView.cpN2Plant_Cap[index]) !== 0)
                   || (Number(SFPGFSupplierFeedbackPartView.cpN2Raw_Comp[index]) !== 0)
                   || (Number(SFPGFSupplierFeedbackPartView.cpN2Raw_Mat[index]) !== 0)) {

                if ((Number(SFPGFSupplierFeedbackPartView.cpN2Supply[index]) < 0)
                    || (SFPGFSupplierFeedbackPartView.cpN2Supply[index] == ''))
                    isErrorSupplyN2 = true;
            }

            if ((Number(SFPGFSupplierFeedbackPartView.cpN3Plant_Cap[index]) !== 0)
                   || (Number(SFPGFSupplierFeedbackPartView.cpN3Raw_Comp[index]) !== 0)
                   || (Number(SFPGFSupplierFeedbackPartView.cpN3Raw_Mat[index]) !== 0)) {

                if ((Number(SFPGFSupplierFeedbackPartView.cpN3Supply[index]) < 0)
                    || (SFPGFSupplierFeedbackPartView.cpN3Supply[index] == ''))
                    isErrorSupplyN3 = true;
            }

            if ((Number(SFPGFSupplierFeedbackPartView.cpNSupply[index]) > 0)
	            && (SFPGFSupplierFeedbackPartView.cpNSupply[index] !== '')) {
                if ((Number(SFPGFSupplierFeedbackPartView.cpNPlant_Cap[index]) === 0)
                   && (Number(SFPGFSupplierFeedbackPartView.cpNRaw_Comp[index]) === 0)
                   && (Number(SFPGFSupplierFeedbackPartView.cpNRaw_Mat[index]) === 0)) {
                    isSuccessSupplyN = false;
                }
            }

            if ((Number(SFPGFSupplierFeedbackPartView.cpN1Supply[index]) > 0)
                && (SFPGFSupplierFeedbackPartView.cpN1Supply[index] !== '')) {
                if ((Number(SFPGFSupplierFeedbackPartView.cpN1Plant_Cap[index]) === 0)
                   && (Number(SFPGFSupplierFeedbackPartView.cpN1Raw_Comp[index]) === 0)
                   && (Number(SFPGFSupplierFeedbackPartView.cpN1Raw_Mat[index]) === 0)) {
                    isSuccessSupplyN1 = false;
                }
            }

            if ((Number(SFPGFSupplierFeedbackPartView.cpN2Supply[index]) > 0)
                && (SFPGFSupplierFeedbackPartView.cpN2Supply[index] !== '')) {
                if ((Number(SFPGFSupplierFeedbackPartView.cpN2Plant_Cap[index]) === 0)
                   && (Number(SFPGFSupplierFeedbackPartView.cpN2Raw_Comp[index]) === 0)
                   && (Number(SFPGFSupplierFeedbackPartView.cpN2Raw_Mat[index]) === 0)) {
                    isSuccessSupplyN2 = false;
                }
            }

            if ((Number(SFPGFSupplierFeedbackPartView.cpN3Supply[index]) > 0)
                && (SFPGFSupplierFeedbackPartView.cpN3Supply[index] !== '')) {
                if ((Number(SFPGFSupplierFeedbackPartView.cpN3Plant_Cap[index]) === 0)
                   && (Number(SFPGFSupplierFeedbackPartView.cpN3Raw_Comp[index]) === 0)
                   && (Number(SFPGFSupplierFeedbackPartView.cpN3Raw_Mat[index]) === 0)) {
                    isSuccessSupplyN3 = false;
                }
            }

            if (SFPGFSupplierFeedbackPartView.cpNReply[index] == '0' || SFPGFSupplierFeedbackPartView.cpNReply[index] == false) {
                SFPGFSupplierFeedbackPartView.cpNPlant_Cap[index] = '0';
                SFPGFSupplierFeedbackPartView.cpNRaw_Comp[index] = '0';
                SFPGFSupplierFeedbackPartView.cpNRaw_Mat[index] = '0';
                SFPGFSupplierFeedbackPartView.cpNSupply[index] = "";
            }

            if (SFPGFSupplierFeedbackPartView.cpN1Reply[index] == '0' || SFPGFSupplierFeedbackPartView.cpN1Reply[index] == false) {
                SFPGFSupplierFeedbackPartView.cpN1Plant_Cap[index] = '0';
                SFPGFSupplierFeedbackPartView.cpN1Raw_Comp[index] = '0';
                SFPGFSupplierFeedbackPartView.cpN1Raw_Mat[index] = '0';
                SFPGFSupplierFeedbackPartView.cpN1Supply[index] = "";
            }

            if (SFPGFSupplierFeedbackPartView.cpN2Reply[index] == '0' || SFPGFSupplierFeedbackPartView.cpN2Reply[index] == false) {
                SFPGFSupplierFeedbackPartView.cpN2Plant_Cap[index] = '0';
                SFPGFSupplierFeedbackPartView.cpN2Raw_Comp[index] = '0';
                SFPGFSupplierFeedbackPartView.cpN2Raw_Mat[index] = '0';
                SFPGFSupplierFeedbackPartView.cpN2Supply[index] = "";
            }

            if (SFPGFSupplierFeedbackPartView.cpN3Reply[index] == '0' || SFPGFSupplierFeedbackPartView.cpN3Reply[index] == false) {
                SFPGFSupplierFeedbackPartView.cpN3Plant_Cap[index] = '0';
                SFPGFSupplierFeedbackPartView.cpN3Raw_Comp[index] = '0';
                SFPGFSupplierFeedbackPartView.cpN3Raw_Mat[index] = '0';
                SFPGFSupplierFeedbackPartView.cpN3Supply[index] = "";
            }
        }

        if (((!isSuccessN) && (isOverAllNGN_Month))
            || ((!isSuccessN1) && (isOverAllNGN_1_Month))
            || ((!isSuccessN2) && (isOverAllNGN_2_Month))
            || ((!isSuccessN3) && (isOverAllNGN_3_Month))) {
            alert('Error ' + ((!isSuccessN) && isOverAllNGN_Month ? '(N_Month)' :
                 ((!isSuccessN1) && isOverAllNGN_1_Month ? '(N_1_Month)' :
                 ((!isSuccessN2) && isOverAllNGN_2_Month ? '(N_2_Month)' : '(N_3_Month)')))
                  + ' : NG Factor Must Filled At Least One Factor for All Part if REPLY is NG');
            popupFeedbackPartGridUpdateProgress.Hide();
            return;
        }

        if ((isErrorN) || (isErrorN1) || (isErrorN2) || (isErrorN3)) {
            alert('Error ' + (isErrorN ? '(N_Month)' : (isErrorN1 ? '(N_1_Month)' : (isErrorN2 ? '(N_2_Month)' : '(N_3_Month)')))
                  + ' : NG Factor Must Filled At Least One Factor Per Row if Reply not Overall and Reply is NG');
            popupFeedbackPartGridUpdateProgress.Hide();
            return;
        }

        if ((isErrorSupplyN) || (isErrorSupplyN1) || (isErrorSupplyN2) || (isErrorSupplyN3)) {
            alert('Error ' + (isErrorSupplyN ? '(N_Month)' : (isErrorSupplyN1 ? '(N_1_Month)' : (isErrorSupplyN2 ? '(N_2_Month)' : '(N_3_Month)')))
                  + ' : Quantity Supply must be Filled if REPLY is NG');
            popupFeedbackPartGridUpdateProgress.Hide();
            return;
        }

        if ((!isSuccessSupplyN) || (!isSuccessSupplyN1) || (!isSuccessSupplyN2) || (!isSuccessSupplyN3)) {
            alert('Error ' + (!isSuccessSupplyN ? '(N_Month)' : (!isSuccessSupplyN1 ? '(N_1_Month)' : (!isSuccessSupplyN2 ? '(N_2_Month)' : '(N_3_Month)')))
                  + ' : NG Factor Cannot be Empty if QTY Supply not Empty and REPLY is NG');
            popupFeedbackPartGridUpdateProgress.Hide();
            return;
        }

        if (isValid) {
            $.ajax({
                type: "POST",
                url: "@Url.Content("~/SupplierFeedbackPart/UpdateFeedbackPart")",
                contentType: "application/json; charset=utf-8",
                dataType: 'JSON',
                data: JSON.stringify(Feedback),
                success: function (result) {
                    popupFeedbackPartGridUpdateProgress.Hide();
                    if (result == "SUCCESS") {
                        lock = "1";
                        popupFeedbackPart.PerformCallback();
                    }
                    else {
                        alert(result);
                        popupFeedbackPart.PerformCallback();
                    }
                },
                error: function (result) {
                    console.log(result);
                    popupFeedbackPartGridUpdateProgress.Hide();
                    alert("Error On Update Supplier Feedback Part Data.");
                }
            });
        }
        else {
            popupFeedbackPartGridUpdateProgress.Hide();
            alert('All input value cannot be empty!');
            popupFeedbackPart.PerformCallback();
        }
    }

    function OnSFPFFDownloadTemplateLinkClick(s, e) {
        $("#SFPGUPMessageLabel").text("Download in progress,\nPlease wait...");
        popupFeedbackPartGridDownloadProgress.Show();

        $.fileDownload("SupplierFeedbackPart/DownloadTemplate/", {
            data: {
                productionMonth: productionMonth,
                supplierCode: supplierCode,
                supplierPlanCode: supplierPlanCode,
                version: version,
                partNo: ""
            },
            successCallback: function (url) {
                popupFeedbackPartGridDownloadProgress.Hide();
            },
            failCallback: function (responseHtml, url) {
                popupFeedbackPartGridDownloadProgress.Hide();

                alert(responseHtml);
            }
        });
    }

    function OnPopupFeedbackPartGridUpdateConfirmationShown(s, e) {

    }

    function OnPopupFeedbackPartGridUpdateConfirmationClosing(s, e) {
        $("#SFPGFUCMessageLabel").text("Are you sure to Confirm ?");
    }

    function OnSFPGFUCCancelButtonClick(s, e) {
        popupFeedbackPartGridUpdateConfirmation.Hide();
    }

    function OnSFPGFUPCOkButtonClick(s, e) {
        popupFeedbackPartGridUploadConfirmation.Hide();
        SFPFFFileUpload.UploadFile();
    }

    function OnPopupFeedbackPartGridUploadConfirmationShown(s, e) {

    }

    function OnSFPGFUPCCancelButtonClick(s, e) {
        popupFeedbackPartGridUploadConfirmation.Hide();
    }

    function OnSFPGUEFileUploadFileUploadComplete(s, e) {
        if (e.isValid) {
            filePath = e.callbackData;

            var filePathArray = filePath.split(".");
            var lastIndex = filePathArray.length - 1;
            var extension = filePathArray[lastIndex];

            if (
                extension != "xls" &&
                extension != "xlsx" //&& 
                //                extension != "pdf" &&
                //                extension != "doc" &&
                //                extension != "docx" &&
                //                extension != "txt" &&
                //                extension != "jpg" &&
                //                extension != "gif" &&
                //                extension != "png"
                ) {
                popupFeedbackPartGridUploadProgress.Hide();
                popupFeedbackPartGridUploadEvidence.Hide();
                popupFeedbackPart.PerformCallback();

                alert("File extension not allowed");
            }
            else {
                popupFeedbackPartGridUploadEvidence.Hide();

                $("#SFPGUPMessageLabel").text("Upload in progress,\nPlease wait...");
                popupFeedbackPartGridUploadProgress.Show();

                $.ajax({
                    type: "POST",
                    url: "@Url.Content("~/SupplierFeedbackPart/UpdateFeedbackPart")",
                    data: {
                        parameterList: parameterList
                    },
                    success: function (result) {
                        popupFeedbackPartGridUploadProgress.Hide();
                        popupFeedbackPartGridUpdateConfirmation.Hide();
                        popupFeedbackPartGridUploadEvidence.Hide();

                        //Disabling Button
                        FFPConfirmButton.SetEnabled(false);
                        SFPRHFOkButton.SetEnabled(false);
                        SFPRHFCancelButton.SetEnabled(false);
                        SFPFFUploadButton.SetEnabled(false);
                        //SFPGFSupplierFeedbackPartView.PerformCallback();
                        ////SFPFFFileUpload.SetEnabled(false);
                        popupFeedbackPart.PerformCallback();
                    },
                    error: function (result) {
                        popupFeedbackPartGridUploadProgress.Hide();
                        popupFeedbackPartGridUpdateConfirmation.Hide();
                        popupFeedbackPartGridUploadEvidence.Hide();

                        alert(result);
                    }
                });
            }
        }
        else {
            popupFeedbackPartGridUploadProgress.Hide();
            popupFeedbackPartGridUploadEvidence.Hide();
            popupFeedbackPart.PerformCallback();

            alert("File extension not allowed");
        }
    }

    function OnSFPGUEOkButtonClick(s, e) {
        // remark by rahmat 2013-09-26
        //        // upload evidence process.

        //        var isRightName = true;
        //        var fullPath = document.getElementById('SFPGUEFileUpload_TextBox0_Input').value;
        //        var filename = "";

        //        if (fullPath) {
        //	        var startIndex = (fullPath.indexOf('\\') >= 0 ? fullPath.lastIndexOf('\\') : fullPath.lastIndexOf('/'));
        //	            filename = fullPath.substring(startIndex);
        //	        if (filename.indexOf('\\') === 0 || filename.indexOf('/') === 0) {
        //		        filename = filename.substring(1);
        //	        }
        //        }

        //        if (filename != "") {
        //            filename = filename.split('.');
        //            var filenameNoExt = filename[0].split(' ');
        //            
        //            if (filenameNoExt.length == 5) {
        //                if (filenameNoExt[0] != "Supplier")
        //                    isRightName = false;

        //                if (filenameNoExt[1] != "Feedback")
        //                    isRightName = false;

        //                if ((filenameNoExt[2].length > 4)||(filenameNoExt[2].length < 4))
        //                    isRightName = false;

        //                if ((filenameNoExt[3].length > 1)||(filenameNoExt[3].length < 1))
        //                    isRightName = false;

        //                if ((filenameNoExt[4].length > 6)||(filenameNoExt[4].length < 6))
        //                    isRightName = false;
        //            } else
        //                isRightName = false;

        //            if (!isRightName)
        //                alert('Filename must be with format Supplier<Space>Feedback<Space>Supplier code<Space>Timing<Space>Production month');

        //        } else {
        //            alert('Please browse evidence file.');
        //            isRightName = false;
        //        }

        //        if (isRightName)
        SFPGUEFileUpload.UploadFile();
    }

    function OnSFPGUECancelButtonClick(s, e) {
        popupFeedbackPartGridUpdateConfirmation.Hide();
        popupFeedbackPartGridUploadEvidence.Hide();
        //popupFeedbackPart.PerformCallback();
    }
    // =============================================================================    

    // ==================== Forecast Detail Data Popup Functions ===================
    function OnFDDetailDataViewLinkClick(s, e) {
        var index = s.name.substring(21);

        index = index - (ForecastDetailView.GetPageIndex() * ForecastDetailView.cpPageSize);

        productionMonth = ForecastDetailView.cpProductionMonth[index];
        supplierCode = ForecastDetailView.cpSupplierCd[index];
        supplierPlanCode = ForecastDetailView.cpSupplierPlant[index];
        version = "";

        popupForecastDetailData.Show();
    }

    function OnPopupForecastDetailDataShown(s, e) {
        popupForecastDetailData.PerformCallback();
    }
    // =============================================================================    
    //---=== Download Template ===---//
    function HlDownloadTemplateLink_Click(s, e) {
        $.fileDownload("SupplierFeedbackPart/Download/", {
            successCallback: function (url) {
                //popupConfirmationProgress.Hide();
            },
            failCallback: function (responseHtml, url) {
                //popupConfirmationProgress.Hide();
                alert(responseHtml);
            }
        });
    }
    //---=== End Download Template ===---//
    function DownloadCoverPOPDF(s, e) {
        var i = s.name.substring(17);
        var poNo = $('#ForecastDetailView').find('#FDLPOPPONo' + i).filter(':first');

        $.fileDownload("POApproval/DownloadPdf/", {
            data: {
                PoNo: poNo.text()
            },
            successCallback: function (url) {
            },
            failCallback: function (responseHtml, url) {
                alert(responseHtml);
            }
        });
    }
</script>

<link href="@Url.Content("~/Content/Style/Forecast.css")" rel="stylesheet" type="text/css"/>
<div style="display:table;border:1px solid #142B94; background-color:#DEECFD; padding:10px;">
    @Html.Action("PartialHeaderForecast", "Forecast")
</div>
<div style="height: 15px;"></div> @* div spacing *@
<div>
    @Html.Action("PartialDetailForecast", "Forecast")
</div>
<div style="height: 100px;">
</div>
@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupFeedbackPart";
    settings.HeaderText = "Monthly Forecast : ";
    settings.CallbackRouteValues = new { Controller = "Forecast", Action = "PartialPopupForecastFeedbackPart" };
    settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(610);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ControlStyle.BackColor = System.Drawing.Color.Transparent;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.Shown = "OnPopupFeedbackPartShown";
    settings.ClientSideEvents.Closing = "OnPopupFeedbackClosing";
    settings.ClientSideEvents.BeginCallback = "OnPopupFeedbackBeginCallback";
    settings.SetContent(() =>
    {
        Html.RenderAction("PartialEmptyPopupForecastFeedbackPart", "Forecast");
    });
}).GetHtml()
@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupForecastDetailData";
    settings.HeaderText = "Forecast Detail Data";
    settings.CallbackRouteValues = new { Controller = "Forecast", Action = "PartialPopupForecastDetailData" };
    settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(400);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.Shown = "OnPopupForecastDetailDataShown";
    //settings.ClientSideEvents.Closing = "OnPopupFeedbackClosing";
    settings.ClientSideEvents.BeginCallback = "OnPopupFeedbackBeginCallback";
    settings.SetContent(() =>
    {
        Html.RenderAction("PartialEmptyPopupForecastDetailData", "Forecast");
    });
}).GetHtml()
@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupForecastDetailUnlockConfirmation";
    settings.HeaderText = "Forecast Unlock Confirmation";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(300);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(250);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.Shown = "OnPopupForecastDetailUnlockConfirmationShown";
    settings.ClientSideEvents.Closing = "OnPopupFeedbackClosing";
    settings.ClientSideEvents.BeginCallback = "OnPopupFeedbackBeginCallback";
    settings.SetContent(() =>
    {
        Html.RenderPartial("ForecastDetailUnlockConfirmationPartial", Model);
    });
}).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupForecastDetailDownloadConfirmation";
    settings.HeaderText = "Forecast Download Confirmation";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(350);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(290);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.Shown = "OnPopupForecastDetailDownloadConfirmationShown";
    settings.ClientSideEvents.Closing = "OnPopupFeedbackClosing";
    settings.ClientSideEvents.BeginCallback = "OnPopupFeedbackBeginCallback";
    settings.SetContent(() =>
    {
        Html.RenderPartial("ForecastDetailDownloadConfirmationPartial", Model);
    });
}).GetHtml()

@Html.DevExpress().PopupControl(
    settings => {
        settings.Name = "popupForecastGridDownloadProgress";
        //settings.HeaderText = "Forecast Download Progress";
        settings.ShowHeader = false;
        settings.Width = System.Web.UI.WebControls.Unit.Pixel(300);
        settings.Height = System.Web.UI.WebControls.Unit.Pixel(150);
        settings.ScrollBars = ScrollBars.Auto;
        settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
        settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
        settings.Modal = true;
        settings.CloseAction = CloseAction.CloseButton;
        settings.ShowPageScrollbarWhenModal = true;
        settings.SetContent(() =>
        {
            Html.RenderPartial("ForecastDetailDownloadProgressPartial", Model);
        });
    }).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupFeedbackPartGridUpdateConfirmation";
    settings.HeaderText = "Suplier Feedback Part Update Confirmation";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(300);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(150);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.Shown = "OnPopupFeedbackPartGridUpdateConfirmationShown";
    settings.ClientSideEvents.Closing = "OnPopupFeedbackPartGridUpdateConfirmationClosing";
    settings.SetContent(() =>
    {
        Html.RenderPartial("~/Views/SupplierFeedbackPart/SupplierFeedbackPartGridUpdateConfirmationPartial_Forecast.cshtml", Model);
    });
}).GetHtml()

@Html.DevExpress().PopupControl(
    settings => {
        settings.Name = "popupFeedbackPartGridUpdateProgress";
        //settings.HeaderText = "Suplier Feedback Part Update Progress";
        settings.ShowHeader = false;
        settings.Width = System.Web.UI.WebControls.Unit.Pixel(300);
        settings.Height = System.Web.UI.WebControls.Unit.Pixel(150);
        settings.ScrollBars = ScrollBars.Auto;
        settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
        settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
        settings.Modal = true;
        settings.CloseAction = CloseAction.CloseButton;
        settings.ShowPageScrollbarWhenModal = true;
        settings.SetContent(() =>
        {
            Html.RenderPartial("~/Views/SupplierFeedbackPart/SupplierFeedbackPartGridUpdateProgressPartial_Forecast.cshtml", Model);
        });
    }).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupFeedbackPartGridUploadConfirmation";
    settings.HeaderText = "Suplier Feedback Part Upload Confirmation";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(300);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(150);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.Shown = "OnPopupFeedbackPartGridUploadConfirmationShown";
    settings.SetContent(() =>
    {
        Html.RenderPartial("~/Views/SupplierFeedbackPart/SupplierFeedbackPartGridUploadConfirmationPartial_Forecast.cshtml", Model);
    });
}).GetHtml()

@Html.DevExpress().PopupControl(
    settings => {
        settings.Name = "popupFeedbackPartGridUploadProgress";
        //settings.HeaderText = "Suplier Feedback Part Upload Progress";
        settings.ShowHeader = false;
        settings.Width = System.Web.UI.WebControls.Unit.Pixel(300);
        settings.Height = System.Web.UI.WebControls.Unit.Pixel(150);
        settings.ScrollBars = ScrollBars.Auto;
        settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
        settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
        settings.Modal = true;
        settings.CloseAction = CloseAction.CloseButton;
        settings.ShowPageScrollbarWhenModal = true;
        settings.SetContent(() =>
        {
            Html.RenderPartial("~/Views/SupplierFeedbackPart/SupplierFeedbackPartGridUploadProgressPartial_Forecast.cshtml", Model);
        });
    }).GetHtml()

@Html.DevExpress().PopupControl(
    settings => {
        settings.Name = "popupFeedbackPartGridDownloadProgress";
        //settings.HeaderText = "Suplier Feedback Part Download Progress";
        settings.ShowHeader = false;
        settings.Width = System.Web.UI.WebControls.Unit.Pixel(300);
        settings.Height = System.Web.UI.WebControls.Unit.Pixel(150);
        settings.ScrollBars = ScrollBars.Auto;
        settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
        settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
        settings.Modal = true;
        settings.CloseAction = CloseAction.CloseButton;
        settings.ShowPageScrollbarWhenModal = true;
        settings.SetContent(() =>
        {
            Html.RenderPartial("~/Views/SupplierFeedbackPart/SupplierFeedbackPartGridDownloadProgressPartial_Forecast.cshtml", Model);
        });
    }).GetHtml()

@Html.DevExpress().PopupControl(
    settings => {
        settings.Name = "popupFeedbackPartGridUploadEvidence";
        settings.HeaderText = "Suplier Feedback Part Upload Evidence";
        settings.Width = System.Web.UI.WebControls.Unit.Pixel(300);
        settings.Height = System.Web.UI.WebControls.Unit.Pixel(200);
        settings.ScrollBars = ScrollBars.Auto;
        settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
        settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
        settings.Modal = true;
        settings.CloseAction = CloseAction.CloseButton;
        settings.ShowPageScrollbarWhenModal = true;
        settings.SetContent(() =>
        {
            Html.RenderPartial("~/Views/SupplierFeedbackPart/SupplierFeedbackPartGridUploadEvidencePartial_Forecast.cshtml", Model);
        });
    }).GetHtml()

@Html.Common().DevExpress().MessageBoard(
    msettings =>
    {
        msettings.Name = "ForecastMessageBoard";
        msettings.BoardName = "Montly Forecast";
        msettings.Position = MessageBoardPosition.RIGHT;
    }
).GetHtml()
